你的位置:首页 > Java教程

[Java教程]异常

1 异常概述

  • 异常是在运行期间发生的不正常的情况。

 

  • 在java中,用类的形式对不正常的情况进行了描述和封装对象,描述不正常情况的类称为异常类。
  • 以前正常流程代码和问题代码相结合,现在将正常流程代码和问题处理代码分离,提高了阅读性。

 

  • 其实,异常就是java通过面向对象的思想将问题封装成对象。

2 异常体系

  • 异常体系,就是异常很多,描述异常的类也很多,将其共性进行了抽取,就形成了体系。

 

  • 异常体系结构图如下所示:

  • Throwable:无论是Error还是Exception,一般发生问题就应该可以抛出,让调用者知道并处理。该体系的特点就在于Throwable及其所有的子类都具有可抛性。其实就是通过throws和throw两个关键字体现的,凡是被这两个关键字所操作的类和对象都具有可抛性。
  • Error:是由JVM抛出的严重性问题。这种问题一旦发生一般不针对性处理。
  • Exception:可以处理。

 

3 异常的原理

  •  示例:
package java011;/** * 2017/9/15 * 说明: */class Demo{ public void method(int[] arr,int index){  System.out.println(arr[index]); }}public class ExceptionDemo { public static void main(String[] args) {  int[] arr = new int[3];  Demo d = new Demo();  d.method(arr,3); }}

4 异常对象的抛出

  • 示例:
package java011;/** * 2017/9/15 * 说明: */class Demo{ public int method(int[] arr,int index){  if(index<0){   throw new RuntimeException("索引不能小于0");  }  if(arr == null || arr.length <=0){   throw new RuntimeException("数组为空或者数组的长度为0");  }  if(arr.length <=index){   throw new ArrayIndexOutOfBoundsException("数组越界"+index);  }  return arr[index]; }}public class ExceptionDemo { public static void main(String[] args) {  int[] arr = new int[3];  Demo d = new Demo();  int result = d.method(arr,3);  System.out.println("结果是:"+result); }}

 

5 自定义异常&异常类的抛出(throws)

package java011;/** * 2017/9/15 * 说明: *//** * 负数角标异常 */class FuShuIndexException extends Exception{ public FuShuIndexException(String str){  super(str); }}class Demo{ public int method(int[] arr,int index) throws FuShuIndexException {  if(index<0){   throw new FuShuIndexException("索引不能小于0");  }  if(arr == null || arr.length <=0){   throw new RuntimeException("数组为空或者数组的长度为0");  }  if(arr.length <=index){   throw new ArrayIndexOutOfBoundsException("数组越界"+index);  }  return arr[index]; }}public class ExceptionDemo { public static void main(String[] args) throws FuShuIndexException {  int[] arr = new int[3];  Demo d = new Demo();  int result = d.method(arr,3);  System.out.println("结果是:"+result); }}

 

6 异常的分类

  • 异常的分类
    • ①编译时被检测异常:只要Exception和其子类都是,除了RuntimException体系。这种问题一旦出现,希望在编译的时候就进行检测,让这种问题有对应的处理方式。这样的问题都可以针对性的处理。
    • ②运行时异常:RuntimeException体系。这种问题的发生,无法让功能继续,运算无法进行,更多是因为调用者的原因导致的或者内部状态的改变导致的。这样的问题一般不针对性处理,直接编译通过,运行时,让调用者调用的程序强制停止。  

 

7 throw和throws的区别?

  • ①throw使用在函数上,throw使用在函数内。
  • ②throws抛出的是异常类,可以抛出多个,用逗号隔开。throw抛出的异常对象。

 

8 异常的捕获

  • 异常捕获的方式
try{}catch(异常类 变量){}finally{}

 

  • 示例:
package java011;/** * 2017/9/15 * 说明: *//** * 负数角标异常 */class FuShuIndexException extends Exception{ public FuShuIndexException(String str){  super(str); }}class Demo{ public int method(int[] arr,int index) throws FuShuIndexException {  if(index<0){   throw new FuShuIndexException("索引不能小于0");  }  if(arr == null || arr.length <=0){   throw new RuntimeException("数组为空或者数组的长度为0");  }  if(arr.length <=index){   throw new ArrayIndexOutOfBoundsException("数组越界"+index);  }  return arr[index]; }}public class ExceptionDemo { public static void main(String[] args) {  int[] arr = new int[3];  Demo d = new Demo();  int result = 0;  try {   result = d.method(arr,3);  } catch (FuShuIndexException e) {   e.printStackTrace();  }  System.out.println("结果是:"+result); }}

 

9 异常处理的原则

  • ①函数内部如果抛出需要检测的异常,那么函数上必须声明。不然,必须在函数内部捕获,如果又不声明,又不捕获,那么会编译失败。
  • ②如果调用到了声明异常的函数,要么捕获要么throws,否则编译失败。
  • ③如果功能内容可以解决的,用catch,解决不了的,用throws告诉调用者,由调用者解决。
  • ④一个如果功能如果抛出了多个异常,那么调用的时候必须有对应的多个catch进行针对性的处理或直接catch(Exception e)。

 

10 异常的注意事项

  • 子类在覆盖父类方法的时候,父类的方法如果抛出了异常,那么子类的方法只能抛出父类的异常或者该异常的子类。
  • 如果父类抛出多个异常,那么子类只能抛出父类异常的子集。